/**
 * Program to create a recursive graphics which looks like broccoli.
 * Written 11/4/99 by Kim Bruce
 * Modified 4/20/00 by Andrea Danyluk
 * 
 * Updated by Jim Teresco for CSC 252, The College of Saint Rose, Fall 2013
 * Code cleanup, Spring 2016
 * 
 * $Id: Broccoli.java 2924 2016-03-31 00:40:33Z terescoj $
 */

import objectdraw.*;
import java.awt.*;

public class Broccoli extends WindowController {
    
    // some named constants for the first broccoli part
    private static final double STEM_X = 200;
    private static final double STEM_Y = 350;
    private static final double STEM_LENGTH = 80;

    // dragging support
    private Location lastLocation;
    private boolean dragging;
    
    // Broccoli object to be drawn and moved
    private BroccoliBranch plant;

    // In begin, we just create the broccoli
    public void begin() {

        plant = new BroccoliBranch(new Location(STEM_X,STEM_Y), STEM_LENGTH, Math.PI/2.0, canvas);
    }

    // Get ready to move broccoli
    public void onMousePress(Location pt) {
        
        dragging = plant.contains(pt);
        lastLocation = pt;
    }

    // Drag the broccoli around
    public void onMouseDrag(Location pt) {
        
        if (dragging) {
            plant.move(pt.getX()-lastLocation.getX(), 
                       pt.getY()-lastLocation.getY());
            lastLocation = pt;
        }
    }
}

